<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfpurchasePOSRequest ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfpurchasePOSRequest
 * @subpackage Arrays
 */
class ArrayOfpurchasePOSRequest extends AbstractStructArrayBase
{
    /**
     * The purchasePOSRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PurchasePOSRequest[]
     */
    public $purchasePOSRequest;
    /**
     * Constructor method for ArrayOfpurchasePOSRequest
     * @uses ArrayOfpurchasePOSRequest::setPurchasePOSRequest()
     * @param \StructType\PurchasePOSRequest[] $purchasePOSRequest
     */
    public function __construct(array $purchasePOSRequest = array())
    {
        $this
            ->setPurchasePOSRequest($purchasePOSRequest);
    }
    /**
     * Get purchasePOSRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PurchasePOSRequest[]|null
     */
    public function getPurchasePOSRequest()
    {
        return isset($this->purchasePOSRequest) ? $this->purchasePOSRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPurchasePOSRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPurchasePOSRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePurchasePOSRequestForArrayConstraintsFromSetPurchasePOSRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfpurchasePOSRequestPurchasePOSRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfpurchasePOSRequestPurchasePOSRequestItem instanceof \StructType\PurchasePOSRequest) {
                $invalidValues[] = is_object($arrayOfpurchasePOSRequestPurchasePOSRequestItem) ? get_class($arrayOfpurchasePOSRequestPurchasePOSRequestItem) : sprintf('%s(%s)', gettype($arrayOfpurchasePOSRequestPurchasePOSRequestItem), var_export($arrayOfpurchasePOSRequestPurchasePOSRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The purchasePOSRequest property can only contain items of type \StructType\PurchasePOSRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set purchasePOSRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PurchasePOSRequest[] $purchasePOSRequest
     * @return \ArrayType\ArrayOfpurchasePOSRequest
     */
    public function setPurchasePOSRequest(array $purchasePOSRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($purchasePOSRequestArrayErrorMessage = self::validatePurchasePOSRequestForArrayConstraintsFromSetPurchasePOSRequest($purchasePOSRequest))) {
            throw new \InvalidArgumentException($purchasePOSRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($purchasePOSRequest) || (is_array($purchasePOSRequest) && empty($purchasePOSRequest))) {
            unset($this->purchasePOSRequest);
        } else {
            $this->purchasePOSRequest = $purchasePOSRequest;
        }
        return $this;
    }
    /**
     * Add item to purchasePOSRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchasePOSRequest $item
     * @return \ArrayType\ArrayOfpurchasePOSRequest
     */
    public function addToPurchasePOSRequest(\StructType\PurchasePOSRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PurchasePOSRequest) {
            throw new \InvalidArgumentException(sprintf('The purchasePOSRequest property can only contain items of type \StructType\PurchasePOSRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->purchasePOSRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PurchasePOSRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PurchasePOSRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PurchasePOSRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PurchasePOSRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PurchasePOSRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string purchasePOSRequest
     */
    public function getAttributeName()
    {
        return 'purchasePOSRequest';
    }
}
